searchNodes=[{"doc":"Erlang interface for interacting with USB devices.","ref":"usb.html","title":"usb","type":"module"},{"doc":"","ref":"usb.html#attach_kernel_driver/2","title":"usb.attach_kernel_driver/2","type":"function"},{"doc":"Claim an interface on a given device handle. You must claim the interface you wish to use before you can perform I/O on any of its endpoints. It is legal to attempt to claim an already-claimed interface, in which case this function just returns ok without doing anything. Claiming of interfaces is a purely logical operation; it does not cause any requests to be sent over the bus. Interface claiming is used to instruct the underlying operating system that your application wishes to take ownership of the interface.","ref":"usb.html#claim_interface/2","title":"usb.claim_interface/2","type":"function"},{"doc":"Clear the halt/stall condition for an endpoint. Endpoints with halt status are unable to receive or transmit data until the halt condition is stalled. You should cancel all pending transfers before attempting to clear the halt condition.","ref":"usb.html#clear_halt/2","title":"usb.clear_halt/2","type":"function"},{"doc":"Close a device handle.","ref":"usb.html#close_device/1","title":"usb.close_device/1","type":"function"},{"doc":"Stop listening for hotplug events.","ref":"usb.html#demonitor_hotplug/1","title":"usb.demonitor_hotplug/1","type":"function"},{"doc":"","ref":"usb.html#detach_kernel_driver/2","title":"usb.detach_kernel_driver/2","type":"function"},{"doc":"Get the number of the bus that a device is connected to.","ref":"usb.html#get_bus_number/1","title":"usb.get_bus_number/1","type":"function"},{"doc":"Get a USB configuration descriptor based on its index.","ref":"usb.html#get_config_descriptor/2","title":"usb.get_config_descriptor/2","type":"function"},{"doc":"Get the address of the device on the bus it is connected to.","ref":"usb.html#get_device_address/1","title":"usb.get_device_address/1","type":"function"},{"doc":"Get the USB device descriptor for a given device.","ref":"usb.html#get_device_descriptor/1","title":"usb.get_device_descriptor/1","type":"function"},{"doc":"Returns a list of USB devices currently attached to the system.","ref":"usb.html#get_device_list/0","title":"usb.get_device_list/0","type":"function"},{"doc":"Get the negotiated connection speed for a device.","ref":"usb.html#get_device_speed/1","title":"usb.get_device_speed/1","type":"function"},{"doc":"Get the number of the port that a device is connected to.","ref":"usb.html#get_port_number/1","title":"usb.get_port_number/1","type":"function"},{"doc":"Get the list of all port numbers from root for the specified device.","ref":"usb.html#get_port_numbers/1","title":"usb.get_port_numbers/1","type":"function"},{"doc":"Equivalent to monitor_hotplug([]) . start listening for hotplug events.","ref":"usb.html#monitor_hotplug/0","title":"usb.monitor_hotplug/0","type":"function"},{"doc":"start listening for hotplug events. The owner process will start receiving the following hotplug events: {usb, device_arrived, Device} and {usb, device_left, Device} . If the enumerate flag is provided, the owner process will received device_arrived events for all devices already plugged into the host.","ref":"usb.html#monitor_hotplug/1","title":"usb.monitor_hotplug/1","type":"function"},{"doc":"Open a device and obtain a device handle. A handle allows you to perform I/O on the device in question.","ref":"usb.html#open_device/1","title":"usb.open_device/1","type":"function"},{"doc":"","ref":"usb.html#read_bulk/4","title":"usb.read_bulk/4","type":"function"},{"doc":"","ref":"usb.html#read_control/7","title":"usb.read_control/7","type":"function"},{"doc":"","ref":"usb.html#read_interrupt/4","title":"usb.read_interrupt/4","type":"function"},{"doc":"Release an interface previously claimed with claim_interface/2 . You should release all claimed interfaces before closing a device handle.","ref":"usb.html#release_interface/2","title":"usb.release_interface/2","type":"function"},{"doc":"","ref":"usb.html#set_configuration/2","title":"usb.set_configuration/2","type":"function"},{"doc":"","ref":"usb.html#write_bulk/4","title":"usb.write_bulk/4","type":"function"},{"doc":"","ref":"usb.html#write_control/7","title":"usb.write_control/7","type":"function"},{"doc":"","ref":"usb.html#write_interrupt/4","title":"usb.write_interrupt/4","type":"function"},{"doc":"","ref":"usb.html#t:alt_setting/0","title":"usb.alt_setting/0","type":"type"},{"doc":"","ref":"usb.html#t:config_descriptor/0","title":"usb.config_descriptor/0","type":"type"},{"doc":"Reference to a USB device attached to the host system.","ref":"usb.html#t:device/0","title":"usb.device/0","type":"opaque"},{"doc":"A map representing the standard USB device descriptor. This descriptor is documented in section 9.6.1 of the USB 3.0 specification.","ref":"usb.html#t:device_descriptor/0","title":"usb.device_descriptor/0","type":"type"},{"doc":"A referenced to an open USB device. This handle is used to perform I/O and other operations. When finished with a device handle, you should call close_device/1 .","ref":"usb.html#t:device_handle/0","title":"usb.device_handle/0","type":"opaque"},{"doc":"Indicates the speed at which the device is operating. unknown The OS doesn't report or know the device speed. low The device is operating at low speed (1.5MBit/s). full The device is operating at full speed (12MBit/s). high The device is operating at high speed (480MBit/s). super The device is operating at super speed (5000MBit/s). super_plus The device is operating at super speed plus (10000MBit/s).","ref":"usb.html#t:device_speed/0","title":"usb.device_speed/0","type":"type"},{"doc":"","ref":"usb.html#t:endpoint/0","title":"usb.endpoint/0","type":"type"},{"doc":"","ref":"usb.html#t:hotplug_monitor/0","title":"usb.hotplug_monitor/0","type":"opaque"},{"doc":"","ref":"usb.html#t:interface_descriptor/0","title":"usb.interface_descriptor/0","type":"type"},{"doc":"","ref":"usb.html#t:monitor_hotplug_flag/0","title":"usb.monitor_hotplug_flag/0","type":"type"},{"doc":"An Erlang application for interfacing with USB peripherals using libusb. This application allows for discovering and communicating with USB peripherals by making use of libusb through a NIF interface. Dependencies This Erlang application library depends on: pkg-config (build only) libusb ≥ 1.0.16 Setup You need to add usb as a dependency to your project. If you are using rebar3 , you can add the following to your rebar.config : { deps , [ { usb , &quot;0.2.0&quot; } ] } . Also ensure that usb is added as a dependency to your application, by updating your .app.src file: { application , my_app , [ { applications , [ kernel , stdlib , usb % &lt;- You need this in your applications list ] } ] } . Usage","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"You can list currently connected USB devices, you can use: &gt; { ok , [ Device | _ ] } = usb : get_device_list ( ) . { ok , [ # Ref &lt; 0.1223016592 . 607256583.114769 &gt; ] } . You can then query the device: &gt; usb : get_device_speed ( Device ) . { ok , high } &gt; usb : get_device_descriptor ( Device ) . { ok , \#{ class_code =&gt; 0 , device_version =&gt; 532 , manufacturer_string_index =&gt; 1 , max_packet_size0 =&gt; 64 , num_configurations =&gt; 1 , product_id =&gt; 33028 , product_string_index =&gt; 0 , protocol_code =&gt; 0 , serial_number_string_index =&gt; 2 , sub_class_code =&gt; 0 , usb_version =&gt; 512 , vendor_id =&gt; 1452 } } &gt; usb : get_config_descriptor ( Device , 0 ) . { ok , \#{ attributes =&gt; 224 , configuration_number =&gt; 1 , description_string_index =&gt; 0 , extra =&gt; &lt;&lt; &gt;&gt; , interfaces =&gt; [ \#{ alt_settings =&gt; [ \#{ class_code =&gt; 3 , description_string_index =&gt; 4 , endpoints =&gt; [ \#{ address =&gt; 129 , attributes =&gt; 3 , extra =&gt; &lt;&lt; &gt;&gt; , interval =&gt; 1 , max_packet_size =&gt; 8 , refresh =&gt; 0 , synch_address =&gt; 0 } ] , extra =&gt; &lt;&lt; 9 , 33 , 1 , 1 , 0 , 1 , 34 , 179 , 0 &gt;&gt; , interface_number =&gt; 0 , protocol_code =&gt; 0 , setting_number =&gt; 0 , sub_class_code =&gt; 0 } ] } ] , max_power =&gt; 500 } }","ref":"readme.html#listing-and-querying-devices","title":"Overview - Listing and querying devices","type":"extras"},{"doc":"The following will start monotoring for USB device arrival and departure: &gt; { ok , Monitor } = usb : monitor_hotplug ( [ enumerate ] ) . { ok , # Ref &lt; 0.731181930 . 70909953.42752 &gt; } The enumerate option will create hotplug notifications about already plugged in devices. Without the option, only newly connected devices will be reported. From this point on, the process monitoring USB hotplug will received one of the following messages: {usb, device_arrived, Device} {usb, device_left, Device} where Device is an opaque reference representing a specific device. these references can be used to interact with the device.","ref":"readme.html#monitoring-usb-device-hotplug","title":"Overview - Monitoring USB device hotplug","type":"extras"},{"doc":"Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html","title":"License","type":"extras"},{"doc":"&quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work.","ref":"license.html#1-definitions","title":"License - 1. Definitions.","type":"extras"},{"doc":"Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license","title":"License - 2. Grant of Copyright License.","type":"extras"},{"doc":"Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license","title":"License - 3. Grant of Patent License.","type":"extras"},{"doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: You must give any other recipients of the Work or Derivative Works a copy of this License; and You must cause any modified files to carry prominent notices stating that You changed the files; and You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License.","ref":"license.html#4-redistribution","title":"License - 4. Redistribution.","type":"extras"},{"doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions.","ref":"license.html#5-submission-of-contributions","title":"License - 5. Submission of Contributions.","type":"extras"},{"doc":"This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file.","ref":"license.html#6-trademarks","title":"License - 6. Trademarks.","type":"extras"},{"doc":"Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON- INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License.","ref":"license.html#7-disclaimer-of-warranty","title":"License - 7. Disclaimer of Warranty.","type":"extras"},{"doc":"In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability","title":"License - 8. Limitation of Liability.","type":"extras"},{"doc":"While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html#9-accepting-warranty-or-additional-liability","title":"License - 9. Accepting Warranty or Additional Liability.","type":"extras"},{"doc":"Copyright, KOPERA AS &lt;hello@kopera.com&gt;. All Rights Reserved.","ref":"notice.html","title":"Copyright","type":"extras"}]